ghcide-2.4.0.0: The core of an IDE

Safe Haskell | Safe-Inferred
Language | Haskell2010

Development.IDE.Main

Contents

- Orphan instances

# Documentation

data Arguments #

Constructors

Arguments |
Fields argsProjectRoot :: Maybe FilePath argCommand :: Command argsLogger :: IO Logger argsRules :: Rules () argsHlsPlugins :: IdePlugins IdeState argsGhcidePlugin :: Plugin Config Deprecated argsSessionLoadingOptions :: SessionLoadingOptions argsIdeOptions :: Config -> Action IdeGhcSession -> IdeOptions argsLspOptions :: Options argsDefaultHlsConfig :: Config argsGetHieDbLoc :: FilePath -> IO FilePath Map project roots to the location of the hiedb for the project argsDebouncer :: IO (Debouncer NormalizedUri) Debouncer used for diagnostics argsHandleIn :: IO Handle argsHandleOut :: IO Handle argsThreads :: Maybe Natural argsMonitoring :: IO Monitoring

defaultArguments :: Recorder (WithPriority Log) -> Logger -> IdePlugins IdeState -> Arguments #

data Command #

Constructors

Check [FilePath] | Typecheck some paths and print diagnostics. Exit code is the number of failures
Db | Run a command in the hiedb
Fields hieOptions :: Options hieCommand :: Command
LSP | Run the LSP server
Custom | User defined
Fields ideCommand :: IdeCommand IdeState

#### Instances

Instances details

Show Command # |
Instance details Defined in Development.IDE.Main Methods showsPrec :: Int -> Command -> ShowS # show :: Command -> String # showList :: [Command] -> ShowS #

newtype IdeCommand state #

Constructors

IdeCommand (state -> IO ()) |

#### Instances

Instances details

Show (IdeCommand st) |
Instance details Defined in Ide.Types Methods showsPrec :: Int -> IdeCommand st -> ShowS # show :: IdeCommand st -> String # showList :: [IdeCommand st] -> ShowS #

isLSP :: Command -> Bool #

commandP :: IdePlugins IdeState -> Parser Command #

defaultMain :: Recorder (WithPriority Log) -> Arguments -> IO () #

testing :: Recorder (WithPriority Log) -> Logger -> IdePlugins IdeState -> Arguments #

data Log #

Constructors

LogHeapStats !Log |
LogLspStart [PluginId] |
LogLspStartDuration !Seconds |
LogShouldRunSubset !Bool |
LogSetInitialDynFlagsException !SomeException |
LogService Log |
LogShake Log |
LogGhcIde Log |
LogLanguageServer Log |
LogSession Log |
LogPluginHLS Log |
LogRules Log |

#### Instances

Instances details

Show Log # |
Instance details Defined in Development.IDE.Main Methods showsPrec :: Int -> Log -> ShowS # show :: Log -> String # showList :: [Log] -> ShowS #
Pretty Log # |
Instance details Defined in Development.IDE.Main Methods pretty :: Log -> Doc ann # prettyList :: [Log] -> Doc ann #

# Orphan instances

Show Command # |
Instance details Methods showsPrec :: Int -> Command -> ShowS # show :: Command -> String # showList :: [Command] -> ShowS #
Show Options # |
Instance details Methods showsPrec :: Int -> Options -> ShowS # show :: Options -> String # showList :: [Options] -> ShowS #